"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const object_1 = require("../../object/object");
const evaluator_1 = require("../evaluator");
const evaluator_2 = require("../evaluator");
exports.default = new object_1.Builtin(function (env, ...args) {
    if (args.length !== 2) {
        return evaluator_1.newError('wrong number of arguments. got=%s, want=2', args.length);
    }
    if (args[0].Type() !== object_1.ARRAY_OBJ && args[1].Type() !== object_1.FUNCTION_OBJ) {
        return evaluator_1.newError('arguments to `array_reduce` must be ARRAY,[FUNCTION], got %s,%s', args[0].Type(), args[1].Type());
    }
    let arr = args[0];
    let arg2 = args[1];
    function reduceOArray(a, fn) {
        return a.Elements.reduce(function (previousValue, currentValue, currentIndex, arr) {
            let args = [previousValue, currentValue, new object_1.OInteger(currentIndex), new object_1.OArray(arr)];
            let ret = evaluator_2.applyFunction(env, fn, args);
            return ret ? ret : new object_1.ONull();
        });
    }
    let out = reduceOArray(arr, arg2);
    return out ? out : new object_1.ONull();
});
//# sourceMappingURL=array_reduce.js.map