"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const object_1 = require("../../object/object");
const evaluator_1 = __importStar(require("../evaluator"));
const lexer_1 = __importDefault(require("../../lexer/lexer"));
const parser_1 = __importDefault(require("../../parser/parser"));
exports.default = new object_1.Builtin(function (env, ...args) {
    if (args.length !== 1) {
        return evaluator_1.newError('wrong number of arguments. got=%s, want=1', args.length);
    }
    let l = new lexer_1.default(args[0].Inspect());
    let p = new parser_1.default(l);
    let program = p.ParseProgram();
    let evaluated = evaluator_1.default(program, env);
    if (evaluated)
        return new object_1.OString(evaluated.Inspect());
    return evaluator_1.NULL;
});
//# sourceMappingURL=eval.js.map