"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const object_1 = require("../../object/object");
const evaluator_1 = require("../evaluator");
const json_parse_1 = require("./json_parse");
const https_1 = __importDefault(require("https"));
function sleep(delay) {
    var startTime = new Date();
    var endTime = null;
    do {
        endTime = new Date();
    } while (endTime - startTime < delay);
}
let out = evaluator_1.NULL;
exports.default = new object_1.Builtin(function (env, ...args) {
    if (args.length > 1) {
        return evaluator_1.newError('wrong number of arguments. got=%s, want=1 or 0', args.length);
    }
    let url = args[0].Inspect();
    https_1.default
        .get(url, resp => {
        let data = '';
        resp.on('data', chunk => (data += chunk));
        resp.on('end', () => (out = JSON.parse(data)));
    })
        .on('error', err => console.error(err.message));
    let i = 0;
    while (!out) {
        console.log(i++, out);
        sleep(1000);
    }
    out = json_parse_1.json_parse(out);
    return out;
});
//# sourceMappingURL=fetch.js.map