"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const object_1 = require("../../object/object");
const evaluator_1 = require("../evaluator");
const fs_1 = __importDefault(require("fs"));
exports.default = new object_1.Builtin(function (env, ...args) {
    if (args.length !== 1) {
        return evaluator_1.newError('wrong number of arguments. got=%s, want=1', args.length);
    }
    if (args[0].Type() !== object_1.STRING_OBJ) {
        return evaluator_1.newError('argument to `file_exists` must be STRING, got %s', args[0].Type());
    }
    let path = args[0].Inspect();
    return new object_1.OBoolean(fs_1.default.existsSync(path));
});
//# sourceMappingURL=file_exists.js.map