"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const object_1 = require("../../object/object");
const evaluator_1 = require("../evaluator");
const fs_1 = __importDefault(require("fs"));
exports.default = new object_1.Builtin(function (env, ...args) {
    if (args.length === 1 || args.length === 2) {
        return evaluator_1.newError('wrong number of arguments. got=%s, want=1|2', args.length);
    }
    if (args[0].Type() !== object_1.STRING_OBJ && (args[1] && args[1].Type() !== object_1.BOOLEAN_OBJ)) {
        return evaluator_1.newError('argument to `file_mkdir` must be STRING|BOOLEAN?, got %s', args[0].Type(), args[1] ? args[1].Type() : null);
    }
    let path = args[0].Inspect();
    let recursive = args[1].toValue();
    try {
        fs_1.default.mkdirSync(path, { recursive });
    }
    catch (e) {
        return evaluator_1.newError(e.message);
    }
    return evaluator_1.NULL;
});
//# sourceMappingURL=file_mkdir.js.map