"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const object_1 = require("../../object/object");
const evaluator_1 = require("../evaluator");
const fs_1 = __importDefault(require("fs"));
const json_parse_1 = require("./json_parse");
exports.default = new object_1.Builtin(function (env, ...args) {
    if (args.length !== 1) {
        return evaluator_1.newError('wrong number of arguments. got=%s, want=1', args.length);
    }
    if (args[0].Type() !== object_1.STRING_OBJ) {
        return evaluator_1.newError('argument to `file_read_json` must be STRING, got %s', args[0].Type());
    }
    let path = args[0].Inspect();
    let content = fs_1.default.readFileSync(path, { encoding: 'UTF8' });
    if (!content)
        return evaluator_1.NULL;
    return json_parse_1.json_parse(JSON.parse(content));
});
//# sourceMappingURL=file_read_json.js.map