"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const object_1 = require("../../object/object");
const evaluator_1 = require("../evaluator");
exports.default = new object_1.Builtin(function (env, ...args) {
    if (args.length !== 2) {
        return evaluator_1.newError('wrong number of arguments. got=%s, want=1', args.length);
    }
    if (args[0].Type() !== object_1.HASH_OBJ) {
        return evaluator_1.newError('arguments to `hash_contains_key` must be HASH, got %s,', args[0].Type());
    }
    if (![object_1.STRING_OBJ, object_1.INTEGER_OBJ, object_1.FLOAT_OBJ, object_1.BOOLEAN_OBJ].includes(args[1].Type())) {
        return evaluator_1.newError('arguments to `hash_contains_key` must be STRING|INTEGER|FLOAT|BOOLEAN, got %s,', args[1].Type());
    }
    let hash = args[0];
    for (let v of hash.Pairs.values()) {
        if (v.Key.toValue() === args[1].toValue()) {
            return new object_1.OBoolean(true);
        }
    }
    return new object_1.OBoolean(false);
});
//# sourceMappingURL=hash_contains_key.js.map