"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const object_1 = require("../../object/object");
const evaluator_1 = require("../evaluator");
exports.default = new object_1.Builtin(function (env, ...args) {
    if (args.length !== 1) {
        return evaluator_1.newError('wrong number of arguments. got=%s, want=1', args.length);
    }
    if (args[0].Type() !== object_1.HASH_OBJ) {
        return evaluator_1.newError('arguments to `hash_keys` must be HASH, got %s,', args[0].Type());
    }
    let hash = args[0];
    let arr = [];
    for (let v of hash.Pairs.values()) {
        arr.push(v.Key);
    }
    return new object_1.OArray(arr);
});
//# sourceMappingURL=hash_keys.js.map