"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const object_1 = require("../../object/object");
const evaluator_1 = require("../evaluator");
exports.default = new object_1.Builtin(function (env, ...args) {
    if (args.length !== 3 && args.length !== 4) {
        return evaluator_1.newError('wrong number of arguments. got=%s, want=3|4', args.length);
    }
    if (args[0].Type() !== object_1.STRING_OBJ ||
        args[1].Type() !== object_1.STRING_OBJ ||
        args[2].Type() !== object_1.STRING_OBJ ||
        (args[3] && args[3].Type() !== object_1.STRING_OBJ)) {
        return evaluator_1.newError('arguments to `regex_replace` must be STRING,STRING,STRING,STRING|NULL got %s,%s,%s,%s', args[0].Type(), args[1].Type(), args[2].Type(), args[3] ? args[3].Type() : null);
    }
    let reg = args[0];
    let repl = args[1];
    let str = args[2];
    let flag = args[3];
    let regex = new RegExp(reg.toValue(), flag ? flag.toValue() : undefined);
    let newString = str.toValue().replace(regex, repl.toValue());
    return new object_1.OString(newString);
});
//# sourceMappingURL=regex_replace.js.map