"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const object_1 = require("../../object/object");
const evaluator_1 = require("../evaluator");
exports.default = new object_1.Builtin(function (env, ...args) {
    if (args.length !== 2 && args.length !== 3) {
        return evaluator_1.newError('wrong number of arguments. got=%s, want=2|3', args.length);
    }
    if (args[0].Type() !== object_1.STRING_OBJ ||
        args[1].Type() !== object_1.STRING_OBJ ||
        (args[2] && args[2].Type() !== object_1.STRING_OBJ)) {
        return evaluator_1.newError('arguments to `regex_search` must be STRING,STRING,STRING|NULL got %s,%s,%s', args[0].Type(), args[1].Type(), args[2] ? args[2].Type() : null);
    }
    let reg = args[0];
    let str = args[1];
    let flag = args[2];
    let regex = new RegExp(reg.toValue(), flag ? flag.toValue() : undefined);
    let matchIndex = str.toValue().search(regex);
    return new object_1.OInteger(matchIndex);
});
//# sourceMappingURL=regex_search.js.map