"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const object_1 = require("../../object/object");
const evaluator_1 = require("../evaluator");
exports.default = new object_1.Builtin(function (env, ...args) {
    if (args.length !== 2) {
        return evaluator_1.newError('wrong number of arguments. got=%s, want=2', args.length);
    }
    if (args[0].Type() !== object_1.STRING_OBJ || args[1].Type() !== object_1.STRING_OBJ) {
        return evaluator_1.newError('arguments to `regex_test` must be STRING,STRING, got %s,%s', args[0].Type(), args[1].Type());
    }
    let reg = args[0];
    let str = args[1];
    let regex = new RegExp(reg.toValue());
    if (regex.test(str.toValue())) {
        return new object_1.OBoolean(true);
    }
    return new object_1.OBoolean(false);
});
//# sourceMappingURL=regex_test.js.map