"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const object_1 = require("../../object/object");
const evaluator_1 = require("../evaluator");
const sprintf_js_1 = require("sprintf-js");
exports.default = new object_1.Builtin(function (env, ...args) {
    if (args.length === 0) {
        return evaluator_1.newError('wrong number of arguments. got=%s, want=>0', args.length);
    }
    if (args[0].Type() !== object_1.STRING_OBJ) {
        return evaluator_1.newError('arguments to `sprintf` must be STRING,[...ANY] got %s', args[0].Type());
    }
    let arg1 = args.shift();
    let format = arg1.Inspect();
    let out = sprintf_js_1.sprintf(format, ...args.map(a => a.toValue()));
    env.Logger.Log(out);
    return evaluator_1.NULL;
});
//# sourceMappingURL=sprintf.js.map