import { NullableOObject } from './object';
import Logger from './logger';
import FileLoader from './file-loader';
export default class Environment {
    store: Map<string, NullableOObject>;
    outer: Environment | null;
    Logger: Logger;
    FileLoader: FileLoader | undefined;
    private _files;
    constructor(logger: Logger, fileLoader?: FileLoader);
    GlobalEnv(): Environment;
    Get(name: string): NullableOObject;
    Set(name: string, val: NullableOObject): NullableOObject;
}
export declare function NewEnvironment(): Environment;
export declare function NewEnclosedEnvironment(outer: Environment): Environment;
export declare function NewNodeEnvironment(): Environment;
export declare function NewBrowserEnvironment(): Environment;
