"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lexer_1 = __importDefault(require("../lexer/lexer"));
const parser_1 = __importDefault(require("./parser"));
const fs_1 = __importDefault(require("fs"));
const Trace = 1, DeclarationErrors = 2, AllErrors = 3;
function ParseFile(fset, filename, src, mode) {
    let [text, err] = readSource(filename, src);
    if (err !== null) {
        return [null, err];
    }
    var p;
    let f;
    try {
        p = new parser_1.default(new lexer_1.default(''));
        let f = p.ParseProgram();
        return [null, err];
    }
    catch (e) {
        return [null, e];
    }
}
exports.ParseFile = ParseFile;
function readSource(filename, src) {
    if (src !== null) {
        if (src instanceof String) {
            return [String(src), null];
        }
        else if (src instanceof fs_1.default.ReadStream) {
            var contents = fs_1.default.readFileSync(filename, 'utf8');
            return [contents, null];
        }
        return [null, new Error('invalid source')];
    }
    return [fs_1.default.readFileSync(filename, 'utf8'), null];
}
//# sourceMappingURL=interface.js.map