import FileSet from './fileset';
import Position from './position';
export default class File {
    set: FileSet;
    name: string;
    base: number;
    size: number;
    lines: number[];
    infos: lineInfo[];
    constructor(set: FileSet, name: string, base: number, size: number, lines?: number[], infos?: lineInfo[]);
    Name(): string;
    Base(): number;
    Size(): number;
    LineCount(): number;
    AddLine(offset: number): void;
    MergeLine(line: number): void;
    SetLines(lines: number[]): boolean;
    SetLinesForContent(content: string[]): void;
    AddLineInfo(offset: number, filename: string, line: number): void;
    Pos(offset: number): Position;
    Offset(p: Position): number;
    Line(p: Position): number;
    PositionFor(p: Position, adjusted: boolean): Position;
    Position(p: Position): Position;
    unpack(offset: number, adjusted: boolean): [string, number, number];
    position(p: Position, adjusted: boolean): Position;
}
declare class lineInfo {
    Offset: number;
    Filename: string;
    Line: number;
    constructor(offset: number, filename: string, line?: number);
    valueOf(): number;
}
export {};
