"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const file_1 = __importDefault(require("./file"));
const position_1 = __importStar(require("./position"));
class FileSet {
    constructor(base) {
        this.Files = [];
        this.Last = null;
        this.Base = base;
    }
    GetBase() {
        let b = this.Base;
        return b;
    }
    AddFile(filename, base, size) {
        if (base < 0) {
            base = this.Base;
        }
        if (base < this.Base || size < 0) {
            throw new Error('illegal base or size');
        }
        let f = new file_1.default(this, filename, base, size, [0]);
        base += size + 1;
        if (base < 0) {
            throw new Error('token.Pos offset overflow (> 2G of source code in file set)');
        }
        this.Base = base;
        this.Files.push(f);
        this.Last = f;
        return f;
    }
    Iterate(f) {
        for (let i = 0;; i++) {
            let file;
            if (i < this.Files.length) {
                file = this.Files[i];
                if (file === null || !f(file)) {
                    break;
                }
            }
        }
        return true;
    }
    File(p) {
        if (p != position_1.NoPos) {
            return this.file(p);
        }
        return null;
    }
    PositionFor(p, adjusted) {
        let pos = new position_1.default(0);
        if (p != position_1.NoPos) {
            let f = this.file(p);
            if (f !== null) {
                pos = f.position(p, adjusted);
            }
        }
        return pos;
    }
    Position(p) {
        return this.PositionFor(p, true);
    }
    file(p) {
        let f = this.Last;
        if (f != null && f.base <= Number(p) && Number(p) <= f.base + f.size) {
            return f;
        }
        let i = searchFiles(this.Files, p.Offset);
        if (i >= 0) {
            let f = this.Files[i];
            if (Number(p) <= f.base + f.size) {
                this.Last = f;
                return f;
            }
        }
        return null;
    }
}
exports.default = FileSet;
function NewFileSet() {
    return new FileSet(1);
}
exports.NewFileSet = NewFileSet;
function searchFiles(a, x) {
    for (let i = 0; i < a.length; i++) {
        if (a[i].Base() > x)
            return i;
    }
    return 0;
}
//# sourceMappingURL=fileset.js.map